Name:           incus
Version:        6.3.0
Release:        2%{?dist}
Summary:        Incus - container and VM manager

License:        Apache-2.0
URL:            https://github.com/lxc/incus
Source0:        https://github.com/lxc/incus/releases/download/v6.3.0/incus-6.3.tar.xz
Source1:        shutdown
Source2:        _incus
Source3:        incus.bash-completion
Source4:        incus.service
Source5:        incus.socket
Source6:        incus-startup.service
Source7:        incus-user.service
Source8:        incus-user.socket
Source9:        incus_config.yaml
Source10:       bin.linux.incus-migrate.x86_64
Source11:       incus.sh
Source12:       incus_logrotate

BuildRequires:  golang
BuildRequires:  git

Provides:       incus-selinux
Provides:       incus-client
Provides:       incus-agent
Provides:       incus-tools
Provides:       incus(x86-64) = %{version}-%{release}
Obsoletes:      incus-tools < 6.3.0
Obsoletes:      incus-client < 6.3.0
Obsoletes:      incus-agent < 6.3.0
Obsoletes:      incus-selinux < 6.3.0

%description
Incus is a system container and VM manager.

%prep
%autosetup -n incus-6.3

%build
export CGO_ENABLED=1
export GOPATH=%{_builddir}/go
export GOBIN=%{_builddir}/go/bin
mkdir -p %{_builddir}/go/bin
mkdir -p %{_builddir}/go/src/github.com/lxc
ln -s %{_builddir}/incus-6.3 %{_builddir}/go/src/github.com/lxc/incus

# Build the binaries
cd %{_builddir}/go/src/github.com/lxc/incus
go build -v -o %{_builddir}/go/bin/incusd ./cmd/incusd
go build -v -o %{_builddir}/go/bin/incus ./cmd/incus
go build -v -o %{_builddir}/go/bin/incus-agent ./cmd/incus-agent
go build -v -o %{_builddir}/go/bin/incus-migrate ./cmd/incus-migrate
go build -v -o %{_builddir}/go/bin/incus-simplestreams ./cmd/incus-simplestreams
go build -v -o %{_builddir}/go/bin/incus-benchmark ./cmd/incus-benchmark
go build -v -o %{_builddir}/go/bin/incus-user ./cmd/incus-user
go build -v -o %{_builddir}/go/bin/lxc-to-incus ./cmd/lxc-to-incus
go build -v -o %{_builddir}/go/bin/lxd-to-incus ./cmd/lxd-to-incus
go build -v -o %{_builddir}/go/bin/fuidshift ./cmd/fuidshift

%install
# Install binaries
mkdir -p %{buildroot}/usr/bin
mkdir -p %{buildroot}/usr/libexec/incus
install -m 0755 %{_builddir}/go/bin/incusd %{buildroot}/usr/libexec/incus/incusd
install -m 0755 %{_builddir}/go/bin/incus %{buildroot}/usr/bin/incus
install -m 0755 %{_builddir}/go/bin/incus-agent %{buildroot}/usr/bin/incus-agent
install -m 0755 %{_builddir}/go/bin/incus-migrate %{buildroot}/usr/bin/incus-migrate
install -m 0755 %{_builddir}/go/bin/incus-simplestreams %{buildroot}/usr/libexec/incus/incus-simplestreams
install -m 0755 %{_builddir}/go/bin/incus-benchmark %{buildroot}/usr/bin/incus-benchmark
install -m 0755 %{_builddir}/go/bin/incus-user %{buildroot}/usr/libexec/incus/incus-user
install -m 0755 %{_builddir}/go/bin/lxc-to-incus %{buildroot}/usr/libexec/incus/lxc-to-incus
install -m 0755 %{_builddir}/go/bin/lxd-to-incus %{buildroot}/usr/libexec/incus/lxd-to-incus
mkdir -p %{buildroot}/usr/bin
install -m 0755 %{_builddir}/go/bin/fuidshift %{buildroot}/usr/bin/fuidshift

# Install logrotate:
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
install -m 0644 %{SOURCE12} %{buildroot}%{_sysconfdir}/logrotate.d/incus

# Install incus YAML config:
mkdir -p %{buildroot}/root
install -m 0644 %{SOURCE9} %{buildroot}/root/incus_config.yaml

# Install migrate binary:
install -m 0755 %{SOURCE10} %{buildroot}/usr/bin/bin.linux.incus-migrate.x86_64

# Install Incus Profile:
mkdir -p %{buildroot}/etc/profile.d
install -m 0755 %{SOURCE11} %{buildroot}/etc/profile.d/incus.sh

# Install systemd unit files
mkdir -p %{buildroot}/usr/lib/systemd/system
install -m 0644 %{SOURCE4} %{buildroot}/usr/lib/systemd/system/incus.service
install -m 0644 %{SOURCE5} %{buildroot}/usr/lib/systemd/system/incus.socket
install -m 0644 %{SOURCE6} %{buildroot}/usr/lib/systemd/system/incus-startup.service
install -m 0644 %{SOURCE7} %{buildroot}/usr/lib/systemd/system/incus-user.service
install -m 0644 %{SOURCE8} %{buildroot}/usr/lib/systemd/system/incus-user.socket

# Install sysctl config
mkdir -p %{buildroot}/usr/lib/sysctl.d
echo 'fs.inotify.max_user_instances = 1024' > %{buildroot}/usr/lib/sysctl.d/10-incus-inotify.conf

# Install sysusers config
mkdir -p %{buildroot}/usr/lib/sysusers.d
echo 'g incus-admin -' > %{buildroot}/usr/lib/sysusers.d/incus.conf
echo 'g incus -' >> %{buildroot}/usr/lib/sysusers.d/incus.conf

# Install tmpfiles config
mkdir -p %{buildroot}/usr/lib/tmpfiles.d
echo 'd /home/incus/cache 0700 root root - -' > %{buildroot}/usr/lib/tmpfiles.d/incus.conf
echo 'd /home/incus/logs 0700 root root - -' >> %{buildroot}/usr/lib/tmpfiles.d/incus.conf
echo 'd /home/incus/storage-pools 0711 root root - -' >> %{buildroot}/usr/lib/tmpfiles.d/incus.conf

# Create necessary directories
mkdir -p %{buildroot}/home/incus/logs
mkdir -p %{buildroot}/home/incus/cache
mkdir -p %{buildroot}/home/incus/storage-pools
mkdir -p %{buildroot}/home/incus/guestapi
mkdir -p %{buildroot}/var/log/incus

# Install documentation and license
mkdir -p %{buildroot}/usr/share/doc/incus
install -m 0644 CODE_OF_CONDUCT.md %{buildroot}/usr/share/doc/incus
install -m 0644 CONTRIBUTING.md %{buildroot}/usr/share/doc/incus
install -m 0644 README.md %{buildroot}/usr/share/doc/incus
install -m 0644 SECURITY.md %{buildroot}/usr/share/doc/incus

mkdir -p %{buildroot}/usr/share/licenses/incus
install -m 0644 COPYING %{buildroot}/usr/share/licenses/incus

# Install additional files
mkdir -p %{buildroot}/usr/share/bash-completion/completions
install -m 0644 %{SOURCE3} %{buildroot}/usr/share/bash-completion/completions/incus

mkdir -p %{buildroot}/usr/share/zsh/site-functions
install -m 0644 %{SOURCE2} %{buildroot}/usr/share/zsh/site-functions/_incus

mkdir -p %{buildroot}/etc/dnsmasq.d
echo '# Tell any system-wide dnsmasq instance to make sure to bind to interfaces
# instead of listening on 0.0.0.0
# WARNING: changes to this file will get lost if incus is removed.
bind-interfaces
except-interface=incusbr0' > %{buildroot}/etc/dnsmasq.d/incus.conf

%files
/usr/libexec/incus/incusd
/usr/bin/incus
/usr/bin/incus-agent
/usr/bin/incus-benchmark
/usr/bin/incus-migrate
/usr/bin/bin.linux.incus-migrate.x86_64
/usr/libexec/incus/incus-simplestreams
/usr/libexec/incus/incus-user
/usr/libexec/incus/lxc-to-incus
/usr/libexec/incus/lxd-to-incus
/usr/bin/fuidshift
/usr/lib/systemd/system/incus.service
/usr/lib/systemd/system/incus.socket
/usr/lib/systemd/system/incus-startup.service
/usr/lib/systemd/system/incus-user.service
/usr/lib/systemd/system/incus-user.socket
/usr/lib/sysctl.d/10-incus-inotify.conf
/usr/lib/sysusers.d/incus.conf
/usr/lib/tmpfiles.d/incus.conf
/usr/share/doc/incus/CODE_OF_CONDUCT.md
/usr/share/doc/incus/CONTRIBUTING.md
/usr/share/doc/incus/README.md
/usr/share/doc/incus/SECURITY.md
/usr/share/licenses/incus/COPYING
/usr/share/bash-completion/completions/incus
/usr/share/zsh/site-functions/_incus
/etc/dnsmasq.d/incus.conf
/home/incus/logs
/home/incus/cache
/home/incus/guestapi
/var/log/incus
/root/incus_config.yaml
/etc/profile.d/incus.sh
/etc/logrotate.d/incus

%license COPYING

%pre
getent group incus-admin >/dev/null || groupadd -r incus-admin
getent group incus >/dev/null || groupadd -r incus
systemd-sysusers --replace=/usr/lib/sysusers.d/incus.conf - <<SYSTEMD_INLINE_EOF || : 
g incus-admin -
g incus - 
SYSTEMD_INLINE_EOF

systemd-tmpfiles --replace=/usr/lib/tmpfiles.d/incus.conf --create - <<SYSTEMD_INLINE_EOF || : 
d /home/incus/cache 0700 root root - -
d /home/incus/logs 0700 root root - -
d /home/incus 0711 root root - -
d /home/incus/storage-pools 0711 root root
SYSTEMD_INLINE_EOF

%post
if [ $1 -eq 1 ] && [ -x "/usr/lib/systemd/systemd-update-helper" ]; then 
    /usr/lib/systemd/systemd-update-helper install-system-units incus.socket || : 
    /usr/lib/systemd/systemd-update-helper install-system-units incus.service || : 
    /usr/lib/systemd/systemd-update-helper install-system-units incus-startup.service || : 
    /usr/lib/systemd/systemd-update-helper install-system-units incus-user.socket || : 
    /usr/lib/systemd/systemd-update-helper install-system-units incus-user.service || : 
fi 

if [ $1 -eq 1 ]; then
    systemctl daemon-reload
    systemctl enable incus.socket
    systemctl start incus.socket

    if [ ! -L /var/lib/incus/unix.socket ];then
        ln -s /home/incus/unix.socket /var/lib/incus/unix.socket
    fi

    # Initialize Incus with the YAML configuration
    /usr/bin/incus network create incusbr0 ipv4.address=auto ipv6.address=auto
    /usr/bin/incus admin init --preseed < /root/incus_config.yaml
fi

%preun
if [ $1 -eq 0 ] && [ -x "/usr/lib/systemd/systemd-update-helper" ]; then 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus.socket || : 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus.service || : 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus-startup.service || : 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus-user.socket || : 
    /usr/lib/systemd/systemd-update-helper remove-system-units incus-user.service || : 
fi 

if [ $1 -eq 0 ]; then
    systemctl daemon-reload
    systemctl stop incus.socket
    systemctl disable incus.socket
fi

%postun
if [ $1 -ge 1 ] && [ -x "/usr/lib/systemd/systemd-update-helper" ]; then 
    /usr/lib/systemd/systemd-update-helper mark-restart-system-units incus.socket || : 
    /usr/lib/systemd/systemd-update-helper mark-restart-system-units incus.service || : 
    /usr/lib/systemd/systemd-update-helper mark-restart-system-units incus-user.socket || : 
    /usr/lib/systemd/systemd-update-helper mark-restart-system-units incus-user.service || : 
fi

if [ $1 -ge 1 ]; then
    systemctl daemon-reload
    systemctl restart incus.socket
fi

%changelog

* Wed Jul 31 2024 Michael Stauber <mstauber@solarspeed.net> - 6.3.0-2
- Updated 6.3.0 build with paths changed to /home/incus where appropriate
- Added /usr/bin/bin.linux.incus-migrate.x86_64
- Added /root/incus_config.yaml
- Added /etc/profile.d/incus.sh
- Added /etc/logrotate.d/incus
- Note: Creation of VMs fails due to "QEMU failed to run feature checks"

* Tue Jul 30 2024 Michael Stauber <mstauber@solarspeed.net> - 6.3.0-1
- Initial package for Incus 6.3.0
